
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class PortfoliosDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const portfolios = await db.portfolios.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        summary: data.summary
        ||
        null
            ,
            
        portfolio_type: data.portfolio_type
        ||
        null
            ,
            
        external_url: data.external_url
        ||
        null
            ,
            
        client_testimonial: data.client_testimonial
        ||
        null
            ,
            
        published_at: data.published_at
        ||
        null
            ,
            
        is_public: data.is_public
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await portfolios.setFreelancer( data.freelancer || null, {
            transaction,
        });
        

        
        await portfolios.setRelated_skills(data.related_skills || [], {
            transaction,
        });
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.portfolios.getTableName(),
                belongsToColumn: 'portfolio_images',
                belongsToId: portfolios.id,
            },
            data.portfolio_images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.portfolios.getTableName(),
                belongsToColumn: 'portfolio_files',
                belongsToId: portfolios.id,
            },
            data.portfolio_files,
            options,
        );
        

        return portfolios;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const portfoliosData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                summary: item.summary
            ||
            null
            ,
            
                portfolio_type: item.portfolio_type
            ||
            null
            ,
            
                external_url: item.external_url
            ||
            null
            ,
            
                client_testimonial: item.client_testimonial
            ||
            null
            ,
            
                published_at: item.published_at
            ||
            null
            ,
            
                is_public: item.is_public
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const portfolios = await db.portfolios.bulkCreate(portfoliosData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < portfolios.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.portfolios.getTableName(),
                    belongsToColumn: 'portfolio_images',
                    belongsToId: portfolios[i].id,
                },
                data[i].portfolio_images,
                options,
            );
        }
        
        for (let i = 0; i < portfolios.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.portfolios.getTableName(),
                    belongsToColumn: 'portfolio_files',
                    belongsToId: portfolios[i].id,
                },
                data[i].portfolio_files,
                options,
            );
        }
        

        return portfolios;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const portfolios = await db.portfolios.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.summary !== undefined) updatePayload.summary = data.summary;
        
        
        if (data.portfolio_type !== undefined) updatePayload.portfolio_type = data.portfolio_type;
        
        
        if (data.external_url !== undefined) updatePayload.external_url = data.external_url;
        
        
        if (data.client_testimonial !== undefined) updatePayload.client_testimonial = data.client_testimonial;
        
        
        if (data.published_at !== undefined) updatePayload.published_at = data.published_at;
        
        
        if (data.is_public !== undefined) updatePayload.is_public = data.is_public;
        
        
        updatePayload.updatedById = currentUser.id;

        await portfolios.update(updatePayload, {transaction});

        
        
        if (data.freelancer !== undefined) {
            await portfolios.setFreelancer(
              
              data.freelancer,
              
              { transaction }
            );
        }
        

        
        
        if (data.related_skills !== undefined) {
            await portfolios.setRelated_skills(data.related_skills, { transaction });
        }
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.portfolios.getTableName(),
                belongsToColumn: 'portfolio_images',
                belongsToId: portfolios.id,
            },
            data.portfolio_images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.portfolios.getTableName(),
                belongsToColumn: 'portfolio_files',
                belongsToId: portfolios.id,
            },
            data.portfolio_files,
            options,
        );
        

        return portfolios;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const portfolios = await db.portfolios.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of portfolios) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of portfolios) {
                await record.destroy({transaction});
            }
        });


        return portfolios;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const portfolios = await db.portfolios.findByPk(id, options);

        await portfolios.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await portfolios.destroy({
            transaction
        });

        return portfolios;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const portfolios = await db.portfolios.findOne(
            { where },
            { transaction },
        );

        if (!portfolios) {
            return portfolios;
        }

        const output = portfolios.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.freelancer = await portfolios.getFreelancer({
            transaction
        });
        
        
        output.portfolio_images = await portfolios.getPortfolio_images({
            transaction
        });
        
        
        output.portfolio_files = await portfolios.getPortfolio_files({
            transaction
        });
        
        
        output.related_skills = await portfolios.getRelated_skills({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'freelancer',
        
        where: filter.freelancer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.freelancer.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.freelancer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },


      {
        model: db.skills,
        as: 'related_skills',
        required: false,
      },


      {
        model: db.file,
        as: 'portfolio_images',
      },

      {
        model: db.file,
        as: 'portfolio_files',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'portfolios',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'portfolios',
                        'summary',
                        filter.summary,
                    ),
                };
            }
            
            if (filter.external_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'portfolios',
                        'external_url',
                        filter.external_url,
                    ),
                };
            }
            
            if (filter.client_testimonial) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'portfolios',
                        'client_testimonial',
                        filter.client_testimonial,
                    ),
                };
            }
            

            
            

            
            if (filter.published_atRange) {
                const [start, end] = filter.published_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.portfolio_type) {
                where = {
                    ...where,
                portfolio_type: filter.portfolio_type,
            };
            }
            
            if (filter.is_public) {
                where = {
                    ...where,
                is_public: filter.is_public,
            };
            }
            


      


      if (filter.related_skills) {
        const searchTerms = filter.related_skills.split('|');

        include = [
          {
            model: db.skills,
            as: 'related_skills_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  name: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.portfolios.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'portfolios',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.portfolios.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

